'From Squeak4.0 of 10 March 2010 [latest update: #7195] on 7 April 2010 at 11:45:29 am'!
Object subclass: #ReleaseBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ReleaseBuilder'!

!ReleaseBuilder commentStamp: '<historical>' prior: 0!
I'm responsible to help people releasing various distribution of Squeak!

ReleaseBuilder subclass: #ReleaseBuilderDeveloper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ReleaseBuilder'!

!ReleaseBuilderDeveloper commentStamp: 'gk 2/28/2005 13:27' prior: 0!
This release builder subclass is used for the official Squeak distribution Basic, which currently is the base image of Squeak.
Full is then built on top of Basic using a loadscript from SqueakMap. Minimal is constructed using another script from SqueakMap that removes packages that are included in Basic.!

ReleaseBuilder subclass: #ReleaseBuilderFor3dot10
	instanceVariableNames: 'repository packagesList mantisNo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ReleaseBuilder'!

!ReleaseBuilderFor3dot10 commentStamp: 'edc 4/5/2007 10:06' prior: 0!
This class has two functions.  One is to hold a few methods that are used by the release team to make an initial or a final release.  These will not be used much.  The other is to manage the update stream.  In general, an update will be a set of Montecello versions.  There will be a "packages" method that lists them, and an "update" method that loads them.  The actual update file will just load these two methods from Montecello and execute them.

Once the 3.10 release cycle is over, this class will be useless except for tracking history.

For do a new update:
With a regular web browser like Firefox you go to http://bugs.squeak.org/view.php?id= nnnn
If you think what this should go into image, then in a Workspace do

Installer mantis createRBforBug: nnnn !

ReleaseBuilderFor3dot10 class
	instanceVariableNames: 'current'!
ReleaseBuilder subclass: #ReleaseBuilderNihongo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ReleaseBuilder'!
ReleaseBuilder subclass: #ReleaseBuilderSqueakland
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ReleaseBuilder'!

!ReleaseBuilder methodsFor: 'utilities' stamp: 'ar 9/27/2005 20:10'!
cleanUpChanges
	"Clean up the change sets"

	"ReleaseBuilder new cleanUpChanges"
	
	| projectChangeSetNames |

	"Delete all changesets except those currently used by existing projects."
	projectChangeSetNames := Project allSubInstances collect: [:proj | proj changeSet name].
	ChangeSet removeChangeSetsNamedSuchThat:
		[:cs | (projectChangeSetNames includes: cs) not].
! !

!ReleaseBuilder methodsFor: 'utilities' stamp: 'mir 11/26/2004 15:28'!
cleanUpEtoys
	"ReleaseBuilder new cleanUpEtoys"


	StandardScriptingSystem removeUnreferencedPlayers.

	(self confirm: 'Remove all projects and players?')
		ifFalse: [^self].
	Project removeAllButCurrent.

	#('Morphic-UserObjects' 'EToy-UserObjects' 'Morphic-Imported' )
		do: [:each | SystemOrganization removeSystemCategory: each]! !

!ReleaseBuilder methodsFor: 'utilities' stamp: 'mir 11/26/2004 15:33'!
finalCleanup
	"ReleaseBuilder new finalCleanup"


	Smalltalk forgetDoIts.

	DataStream initialize.
	Behavior flushObsoleteSubclasses.

	"The pointer to currentMethod is not realy needed (anybody care to fix this) and often holds on to obsolete bindings"
	MethodChangeRecord allInstancesDo: [:each | each noteNewMethod: nil].

	self cleanUpEtoys.
	SmalltalkImage current fixObsoleteReferences.

	Smalltalk flushClassNameCache.
	3 timesRepeat: [
		Smalltalk garbageCollect.
		Symbol compactSymbolTable.
	].
! !

!ReleaseBuilder methodsFor: 'utilities' stamp: 'mir 11/25/2004 17:41'!
finalStripping
	"ReleaseBuilder new finalStripping"
! !

!ReleaseBuilder methodsFor: 'utilities' stamp: 'stephaneducasse 2/3/2006 22:23'!
fixObsoleteReferences
	"ReleaseBuilder new fixObsoleteReferences"

	| informee obsoleteBindings obsName realName realClass |
	Preference allInstances do: [:each | 
		informee := each instVarNamed: #changeInformee.
		((informee isKindOf: Behavior)
			and: [informee isObsolete])
			ifTrue: [
				Transcript show: each name; cr.
				each instVarNamed: #changeInformee put: (Smalltalk at: (informee name copyReplaceAll: 'AnObsolete' with: '') asSymbol)]].
 
	CompiledMethod allInstances do: [:method |
		obsoleteBindings := method literals select: [:literal |
			literal isVariableBinding
				and: [literal value isBehavior]
				and: [literal value isObsolete]].
		obsoleteBindings do: [:binding |
			obsName := binding value name.
			Transcript show: obsName; cr.
			realName := obsName copyReplaceAll: 'AnObsolete' with: ''.
			realClass := Smalltalk at: realName asSymbol ifAbsent: [UndefinedObject].
			binding isSpecialWriteBinding
				ifTrue: [binding privateSetKey: binding key value: realClass]
				ifFalse: [binding key: binding key value: realClass]]].


	Behavior flushObsoleteSubclasses.
	Smalltalk garbageCollect; garbageCollect.
	SystemNavigation default obsoleteBehaviors size > 0
		ifTrue: [SystemNavigation default inspect]! !

!ReleaseBuilder methodsFor: 'utilities' stamp: 'ar 9/27/2005 21:44'!
initialCleanup
	"Perform various image cleanups in preparation for making a Squeak gamma release candidate image."
	"ReleaseBuilder new initialCleanup"
	
	Undeclared removeUnreferencedKeys.
	StandardScriptingSystem initialize.

	(Object classPool at: #DependentsFields) size > 1 ifTrue: [self error:'Still have dependents'].
	Undeclared isEmpty ifFalse: [self error:'Please clean out Undeclared'].

	Smalltalk at: #Browser ifPresent:[:br| br initialize].
	ScriptingSystem deletePrivateGraphics.  "?"
	
	self cleanUpChanges.
	ChangeSet current clear.
	ChangeSet current name: 'Unnamed1'.
	Smalltalk garbageCollect.

	"Reinitialize DataStream; it may hold on to some zapped entitities"
	DataStream initialize.

	Smalltalk garbageCollect.
	ScheduledControllers := nil.
	Smalltalk garbageCollect.
	
	SMSqueakMap default purge.
	
! !

!ReleaseBuilder methodsFor: 'utilities' stamp: 'mir 11/25/2004 16:25'!
installPreferences
	Preferences initialize.
	Preferences chooseInitialSettings.
! !

!ReleaseBuilder methodsFor: 'utilities' stamp: 'mir 11/26/2004 11:02'!
installReleaseSpecifics
	"ReleaseBuilder new installReleaseSpecifics"
! !

!ReleaseBuilder methodsFor: 'utilities' stamp: 'mir 11/25/2004 17:53'!
installVersionInfo
	"ReleaseBuilder new installVersionInfo"
! !

!ReleaseBuilder methodsFor: 'utilities' stamp: 'mir 11/25/2004 17:58'!
prepareReleaseImage
	"Perform various image cleanups in preparation for making a Squeak gamma release candidate image."
	"ReleaseBuilder new prepareReleaseImage"
	
	(self confirm: 'Are you sure you want to prepare a release image?
This will perform several irreversible cleanups on this image.')
		ifFalse: [^ self].

	self
		initialCleanup;
		installPreferences;
		finalStripping;
		installReleaseSpecifics;
		finalCleanup;
		installVersionInfo
! !

!ReleaseBuilder methodsFor: 'squeakland' stamp: 'sd 9/26/2004 13:35'!
makeSqueaklandRelease
	"ReleaseBuilder new makeSqueaklandRelease"

	self 
		makeSqueaklandReleasePhasePrepare; 		makeSqueaklandReleasePhaseStripping; 		makeSqueaklandReleasePhaseFinalSettings; 		makeSqueaklandReleasePhaseCleanup! !

!ReleaseBuilder methodsFor: 'squeakland' stamp: 'ar 9/27/2005 21:45'!
makeSqueaklandReleasePhaseCleanup
	"ReleaseBuilder new makeSqueaklandReleasePhaseCleanup"

	Smalltalk at: #Browser ifPresent:[:br| br initialize].
	ChangeSet 
		removeChangeSetsNamedSuchThat: [:cs | cs name ~= ChangeSet current name].
	ChangeSet current clear.
	ChangeSet current name: 'Unnamed1'.
	Smalltalk garbageCollect.
	"Reinitialize DataStream; it may hold on to some zapped entitities"
	DataStream initialize.
	"Remove existing player references"
	References keys do: [:k | References removeKey: k].
	Smalltalk garbageCollect.
	ScheduledControllers := nil.
	Behavior flushObsoleteSubclasses.
	Smalltalk
		garbageCollect;
		garbageCollect.
	SystemNavigation default obsoleteBehaviors isEmpty 
		ifFalse: [self error: 'Still have obsolete behaviors'].

	"Reinitialize DataStream; it may hold on to some zapped entitities"
	DataStream initialize.
	Smalltalk fixObsoleteReferences.
	Smalltalk abandonTempNames.
	Smalltalk zapAllOtherProjects.
	Smalltalk forgetDoIts.
	Smalltalk flushClassNameCache.
	3 timesRepeat: 
			[Smalltalk garbageCollect.
			Symbol compactSymbolTable]! !

!ReleaseBuilder methodsFor: 'squeakland' stamp: 'md 2/24/2006 15:18'!
makeSqueaklandReleasePhaseFinalSettings
	"ReleaseBuilder new makeSqueaklandReleasePhaseFinalSettings"

	| serverName serverURL serverDir updateServer highestUpdate newVersion |

	ProjectLauncher splashMorph: (FileDirectory default readOnlyFileNamed: 'scripts\SqueaklandSplash.morph') fileInObjectAndCode.

	"Dump all morphs so we don't hold onto anything"
	World submorphsDo:[:m| m delete].

	#(
		(honorDesktopCmdKeys false)
		(warnIfNoChangesFile false)
		(warnIfNoSourcesFile false)
		(showDirectionForSketches true)
		(menuColorFromWorld false)
		(unlimitedPaintArea true)
		(useGlobalFlaps false)
		(mvcProjectsAllowed false)
		(projectViewsInWindows false)
		(automaticKeyGeneration true)
		(securityChecksEnabled true)
		(showSecurityStatus false)
		(startInUntrustedDirectory true)
		(warnAboutInsecureContent false)
		(promptForUpdateServer false)
		(fastDragWindowForMorphic false)

		(externalServerDefsOnly true)
		(expandedFormat false)
		(eToyFriendly true)
		(eToyLoginEnabled true)
		(magicHalos true)
		(mouseOverHalos true)
		(biggerHandles false)
		(selectiveHalos true)
		(includeSoundControlInNavigator true)
		(readDocumentAtStartup true)
		(preserveTrash true)
		(slideDismissalsToTrash true)

	) do:[:spec|
		Preferences setPreference: spec first toValue: spec last].
	"Workaround for bug"
	Preferences enable: #readDocumentAtStartup.

	World color: (Color r: 0.9 g: 0.9 b: 1.0).

	"Clear all server entries"
	ServerDirectory serverNames do: [:each | ServerDirectory removeServerNamed: each].
	SystemVersion current resetHighestUpdate.

	"Add the squeakalpha update stream"
	serverName := 'Squeakalpha'.
	serverURL := 'squeakalpha.org'.
	serverDir := serverURL , '/'.

	updateServer := ServerDirectory new.
	updateServer
		server: serverURL;
		directory: 'updates/';
		altUrl: serverDir;
		user: 'sqland';
		password: nil.
	Utilities updateUrlLists addFirst: {serverName. {serverDir. }.}.

	"Add the squeakland update stream"
	serverName := 'Squeakland'.
	serverURL := 'squeakland.org'.
	serverDir := serverURL , '/'.

	updateServer := ServerDirectory new.
	updateServer
		server: serverURL;
		directory: 'public_html/updates/';
		altUrl: serverDir.
	Utilities updateUrlLists addFirst: {serverName. {serverDir. }.}.

	highestUpdate := SystemVersion current highestUpdate.
	(self confirm: 'Reset highest update (' , highestUpdate printString , ')?')
		ifTrue: [SystemVersion current highestUpdate: 0].

	newVersion := UIManager default request: 'New version designation:' initialAnswer: 'Squeakland 3.8.' , highestUpdate printString. 
	SystemVersion newVersion: newVersion.
	(self confirm: self version , '
Is this the correct version designation?
If not, choose no, and fix it.') ifFalse: [^ self].
! !

!ReleaseBuilder methodsFor: 'squeakland' stamp: 'ar 9/27/2005 21:45'!
makeSqueaklandReleasePhasePrepare
	"ReleaseBuilder new makeSqueaklandReleasePhasePrepare"

	Undeclared removeUnreferencedKeys.
	StandardScriptingSystem initialize.
	Preferences initialize.
	"(Object classPool at: #DependentsFields) size > 1 ifTrue: [self error:'Still have dependents']."
	Undeclared isEmpty ifFalse: [self error:'Please clean out Undeclared'].

	"Dump all projects"
	Project allSubInstancesDo:[:prj| prj == Project current ifFalse:[Project deletingProject: prj]].

	"Set new look so we don't need older fonts later"
	StandardScriptingSystem applyNewEToyLook.

	Smalltalk at: #Browser ifPresent:[:br| br initialize].
	ScriptingSystem deletePrivateGraphics.
	ChangeSet removeChangeSetsNamedSuchThat:
		[:cs| cs name ~= ChangeSet current name].
	ChangeSet current clear.
	ChangeSet current name: 'Unnamed1'.
	Smalltalk garbageCollect.
	"Reinitialize DataStream; it may hold on to some zapped entitities"
	DataStream initialize.
	"Remove existing player references"
	References keys do:[:k| References removeKey: k].

	Smalltalk garbageCollect.
	ScheduledControllers := nil.
	Smalltalk garbageCollect.
! !

!ReleaseBuilder methodsFor: 'squeakland' stamp: 'sd 9/26/2004 13:35'!
makeSqueaklandReleasePhaseStripping
	"ReleaseBuilder new makeSqueaklandReleasePhaseStripping"

	#(#Helvetica #Palatino #Courier #ComicSansMS )
		do: [:n | TextConstants
				removeKey: n
				ifAbsent: []].
	Smalltalk
		at: #Player
		ifPresent: [:superCls | superCls
				allSubclassesDo: [:cls | 
					cls isSystemDefined
						ifFalse: [cls removeFromSystem].
					cls := nil]].
	Smalltalk garbageCollect.
	Smalltalk discardFFI; discardSUnit; discardSpeech; yourself.
	"discardMVC;"
	SystemOrganization removeEmptyCategories.
	Smalltalk garbageCollect.
	ScheduledControllers := nil.
	Behavior flushObsoleteSubclasses.
	Smalltalk garbageCollect; garbageCollect.
	DataStream initialize.
	Smalltalk fixObsoleteReferences! !


!ReleaseBuilderDeveloper methodsFor: 'utilities' stamp: 'mir 11/26/2004 16:18'!
cleanUpChanges
	"Clean up the change sets"

	"ReleaseBuilderDeveloper new cleanUpChanges"
	
! !

!ReleaseBuilderDeveloper methodsFor: 'utilities' stamp: 'mir 4/7/2005 11:56'!
installPreferences
	super installPreferences.
	#(
		(updateFromServerAtStartup true)

	) do:[:spec|
		Preferences setPreference: spec first toValue: spec last]! !

!ReleaseBuilderDeveloper methodsFor: 'utilities' stamp: 'stephaneducasse 2/3/2006 22:23'!
installReleaseSpecifics
	"Currently just clear and add the ServerDirectories
	and update streams we want as default."

	"Clear all server entries"
	ServerDirectory serverNames do: [:each | ServerDirectory removeServerNamed: each].

	"Add default entries, added an entry for the new file area.
	The others are the current ones that see to work 
	as of 2005-02-28 and I recreated them using source."
	ServerDirectory addServer: (ServerDirectory new 
		type: #ftp;
		user: '';
		server: 'box1.squeakfoundation.org';
		altUrl: 'http://box1.squeakfoundation.org/files';
		directory: 'files';
		keepAlive: false) named: 'Squeak.org Archive'.
	ServerDirectory addServer: (ServerDirectory new 
		type: #ftp;
		server: 'st.cs.uiuc.edu';
		user: 'anonymous';
		directory: '/Smalltalk/Squeak';
		keepAlive: false) named: 'UIUC Archive'.	
	ServerDirectory addServer: (ServerDirectory new 
		type: #ftp;
		server: 'ftp.create.ucsb.edu';
		user: 'anonymous';
		directory: '/pub/Smalltalk/Squeak';
		keepAlive: false) named: 'UCSBCreate Archive'.
	ServerDirectory addServer: SuperSwikiServer defaultSuperSwiki named: 'Bob SuperSwiki'.
	ServerDirectory addServer: (SuperSwikiServer new 
		type: #http;
		server: 'squeakland.org:8080';
		altUrl: 'http://www.squeakland.org/uploads';
		directory: '/super/SuperSwikiProj';
		keepAlive: false;
		acceptsUploads: true) named: 'Squeakland SuperSwiki'.
	ServerDirectory addServer: (HTTPServerDirectory new 
		type: #ftp;
		user: 'sqland';
		server: 'www.squeakland.org';
		altUrl: 'http://www.squeakland.org/projects';
		directory: 'projects';
		keepAlive: false) named: 'Squeakland Projects'.

"Add the update streams here just as Squeakland does?
	serverName := 'Squeakland'.
	serverURL := 'squeakland.org'.
	serverDir := serverURL , '/'.
	updateServer := ServerDirectory new.
	updateServer
		server: serverURL;
		directory: 'public:=html/updates/';
		altUrl: serverDir.
	Utilities updateUrlLists addFirst: {serverName. {serverDir. }.}.
"
! !


!ReleaseBuilderFor3dot10 methodsFor: 'managing updates' stamp: 'edc 4/5/2007 10:18'!
addRepositoryToPackageNamed: aString
	
	|pa|
	pa := MCPackage named: aString.
	pa workingCopy repositoryGroup addRepository: self repository.
	^pa workingCopy repositoryGroup
! !

!ReleaseBuilderFor3dot10 methodsFor: 'managing updates' stamp: 'rej 3/5/2007 08:17'!
flushCaches

	MCFileBasedRepository flushAllCaches.
	MCDefinition clearInstances.
	Smalltalk garbageCollect.
	
	"Initialization required for tests: strange why this is not a teardwon method"
	SendCaches initializeAllInstances.! !

!ReleaseBuilderFor3dot10 methodsFor: 'managing updates' stamp: 'edc 6/24/2007 10:07'!
loadPackages: packageNames
	self loadTogether: (packageNames findTokens: ' ', String cr) merge: false! !

!ReleaseBuilderFor3dot10 methodsFor: 'managing updates' stamp: 'edc 7/14/2007 07:01'!
loadTogether: aCollection merge: aBoolean
	| loader |
	loader := aBoolean
		ifTrue: [ MCVersionMerger new ]
		ifFalse: [ MCVersionLoader new].
	aCollection do: [:eachVersion | self addRepositoryToPackageNamed: (eachVersion copyUpTo: $- )].
	(self newerVersionsIn: aCollection)
		do: [:fn | loader addVersion: (self repository loadVersionFromFileNamed: fn)]
  	  	displayingProgress: 'Adding versions...'.
	aBoolean
		ifTrue: [[loader merge] on: MCMergeResolutionRequest do: [:request |
					request merger conflicts isEmpty
						ifTrue: [request resume: true]
						ifFalse: [request pass]]]
		ifFalse: [loader load].
		SystemNavigation default obsoleteBehaviors size > 0
        ifTrue: [
            SystemNavigation default obsoleteBehaviors inspect.
            self error:'The changes should be reviewed'].
self flushCaches

! !

!ReleaseBuilderFor3dot10 methodsFor: 'managing updates' stamp: 'rej 1/29/2007 21:49'!
newerVersionsIn: aCollection
	^aCollection reject: [:each |
		MCWorkingCopy allManagers anySatisfy: [:workingcopy |
			workingcopy ancestry ancestorString , '.mcz' = each]].! !

!ReleaseBuilderFor3dot10 methodsFor: 'managing updates' stamp: 'rej 1/29/2007 21:58'!
updatePackages: packageNames
	self loadTogether: (packageNames findTokens: ' ', String cr) merge: true! !

!ReleaseBuilderFor3dot10 methodsFor: 'squeakThreeTen' stamp: 'rej 1/29/2007 22:27'!
advanceToThreeDotTenAlpha

"Offer the chance to advance the version number."
(self confirm: 'There are no further updates for Squeak 3.9.
Do you wish to advance to version 3.10alpha?
[Yes] Your system will be marked as 3.10alpha, and you will
subsequently receive ''test pilot'' updates for 3.10.
[No] Your system will be marked as 3.9, allowing you
to receive only final fixes for the 3.9 stable release.
[Neither] You may choose No, and immediately quit without saving,
allowing you to make a backup copy before adopting this change.
DO YOU WANT TO ADVANCE to Version 3.10alpha now?')
	ifTrue: [SystemVersion newVersion: 'Squeak3.10alpha'.
			SystemVersion current date: Time now asDate.
			self inform: 'You may now save this Version 3.10alpha image
and retrieve updates again for 3.10alpha and beyond.']
	ifFalse: [SystemVersion current version: 'Squeak3.9'; date: Time now asDate..
			self inform: 'You may now save this Version 3.9 final image
and retrieve updates again for any final fixes to 3.9.
- - - - -
(If you quit without saving now, your image will revert to
3.9without any of the updates you just loaded)']! !

!ReleaseBuilderFor3dot10 methodsFor: 'squeakThreeTen' stamp: 'rej 1/29/2007 21:33'!
createBackgroundColor
| gf |
gf := GradientFillStyle  ramp: {0.0->(Color r: 0.97 g: 0.98 b: 1.0) .
1.0->(Color r: 0.0 g: 0.658 b: 0.474)}.
	gf	origin: 0 @ 0;
		direction: 0@400;
		normal: 640@0;
		radial: false.
World fillStyle: gf

! !

!ReleaseBuilderFor3dot10 methodsFor: 'squeakThreeTen' stamp: 'edc 2/27/2007 07:20'!
makeSqueakRelease
	| monti |
		
	self unloadSome.
	
	monti := MCWorkingCopyBrowser new.
	monti unsortedWorkingCopies
		do: [:ea | ((PackageOrganizer default packageNames) includes: (ea package name)) ifFalse:[ ea unregister]].
	monti flushAllCaches.
	
	
	3
		timesRepeat: [Smalltalk garbageCollect].
	DataStream initialize.
	Flaps replaceGlobalFlapwithID: 'Tools' translated.
	Flaps replaceGlobalFlapwithID: 'Widgets' translated.
	self cleanUpEtoys.
	SmalltalkImage current fixObsoleteReferences.
	
	Smalltalk garbageCollect.
	ScheduledControllers := nil.
	Behavior flushObsoleteSubclasses.
	3
		timesRepeat: [Smalltalk garbageCollect]! !

!ReleaseBuilderFor3dot10 methodsFor: 'squeakThreeTen' stamp: 'edc 3/8/2007 09:24'!
makeSqueakThreeTenRelease
	"ReleaseBuilderFor3dot10 new makeSqueakThreeTenRelease"

	self 
		makeSqueakThreeTenReleasePhasePrepare;
		makeSqueakRelease; 		
		makeSqueakThreeTenReleasePhaseCleanup;
		installInBoxAnd310;
	updateFrom7067;
		createBackgroundColor! !

!ReleaseBuilderFor3dot10 methodsFor: 'squeakThreeTen' stamp: 'edc 4/6/2007 06:57'!
makeSqueakThreeTenReleasePhaseCleanup
	"ReleaseBuilderFor3dot10 new makeSqueakThreeTenReleasePhaseCleanup"
| newVersion |
	Smalltalk at: #Browser ifPresent:[:br| br initialize].
self cleanUnwantedCs.
	"Remove existing player references"
	References keys do: [:k | References removeKey: k].
	Smalltalk garbageCollect.
	ScheduledControllers := nil.
	Behavior flushObsoleteSubclasses.
	SystemNavigation default obsoleteBehaviors isEmpty 
		ifFalse: [self error: 'Still have obsolete behaviors'].

	"Reinitialize DataStream; it may hold on to some zapped entitities"
	DataStream initialize.
	self fixObsoleteReferences.
	"Smalltalk abandonTempNames."
	Smalltalk zapAllOtherProjects.
	Smalltalk forgetDoIts.
	Smalltalk flushClassNameCache.
	3 timesRepeat: 
			[Smalltalk garbageCollect.
			Symbol compactSymbolTable].
"SystemVersion current registerUpdate: 7069." "We only need for when start the release"
	newVersion := 'Squeak3.10alpha.' , SystemVersion current
highestUpdate printString. 

	
	newVersion := newVersion ,'.'.
	(SourceFiles at: 2) ifNotNil:
		[SmalltalkImage current closeSourceFiles; "so copying the
changes file will always work"
			 saveChangesInFileNamed: (SmalltalkImage current
fullNameForChangesNamed: newVersion)].
	SmalltalkImage current saveImageInFileNamed: (SmalltalkImage current
fullNameForImageNamed: newVersion)
		! !

!ReleaseBuilderFor3dot10 methodsFor: 'squeakThreeTen' stamp: 'edc 4/5/2007 07:12'!
makeSqueakThreeTenReleasePhasePrepare
	"ReleaseBuilderFor3dot10 new makeSqueakThreeTenReleasePhasePrepare"

	Undeclared removeUnreferencedKeys.
	StandardScriptingSystem initialize.
	Preferences initialize.
	"(Object classPool at: #DependentsFields) size > 1 ifTrue: [self
error:'Still have dependents']."
	Undeclared isEmpty ifFalse: [self error:'Please clean out
Undeclared'].

	"Dump all projects"
	Project allSubInstancesDo:[:prj| prj == Project current
ifFalse:[Project deletingProject: prj]].

	"Set new look so we don't need older fonts later"
	StandardScriptingSystem applyNewEToyLook.

	Smalltalk at: #Browser ifPresent:[:br| br initialize].
	ScriptingSystem deletePrivateGraphics.
	self cleanUnwantedCs.
	"Reinitialize DataStream; it may hold on to some zapped entitities"
	DataStream initialize.
	"Remove existing player references"
	References keys do:[:k| References removeKey: k].

	Smalltalk garbageCollect.
	ScheduledControllers := nil.
	Smalltalk garbageCollect.
! !

!ReleaseBuilderFor3dot10 methodsFor: 'squeakThreeTen' stamp: 'edc 2/24/2007 12:01'!
testObsolete
"if we do some classes go, also his test should go"
^#(WatchMorphTest)! !

!ReleaseBuilderFor3dot10 methodsFor: 'squeakThreeTen' stamp: 'edc 6/28/2007 07:42'!
unloadMorphicClasses

"These classes don't seem to be used, so unload them.  They always can be loaded later."

SystemOrganization classifyAll: #(BorderedStringMorph MouseActionIndicatorMorph CommandTilesMorph
TestClickExerciser SpectrumAnalyzerMorph FishEyeMorph SoundDemoMorph
MultiuserTinyPaint KidNavigationMorph CodecDemoMorph BlobMorph
 SoundMorph SubpaneDividerMorph
RolloverButtonMorph ClipboardMorph VeryPickyMorph
ClassRepresentativeMorph PhraseWrapperMorph WatchMorph
UpdatingTextMorph PluggableTabBarMorph PartsWindow HeadingMorph
ZoomMorph UpdatingStringMorphWithArgument SoundSequencerMorph
ImageMorphWithSpotlight TinyPaint InfoStringMorph
UpdatingBooleanStringMorph DrawErrorMorph ViewerRow
BalloonRectangleMorph  ViewerEntry MidiInputMorph
CachingMorph MovingEyeMorph MIDIPianoKeyboardMorph
DoubleClickExample MorphExample RulerMorph LabelStringMorph) under:
'Morphic-CandidatesForGo'.

(MCPackage named: 'Morphic-CandidatesForGo') unload .
#(TheWorldMenu FileServices AppRegistry Preferences FileList) do: [:cl|
(Smalltalk at: cl) removeObsolete].
self testObsolete do: [:cl|
Smalltalk removeClassNamed: cl].
3 timesRepeat: [Smalltalk garbageCollect].! !

!ReleaseBuilderFor3dot10 methodsFor: 'squeakThreeTen' stamp: 'edc 4/13/2007 18:46'!
unloadSome
	World removeAllMorphs.
	CommandHistory resetAllHistory.
	#('Flash' 'StarSqueak' 'SmaCC' 'Speech' 'Movies' 'FixUnderscores' 'OB' 'OmniBrowser' )
		do: [:ea | (MCPackage named: ea) unload.
			PackageOrganizer default unregisterPackageNamed: ea].
	#(#TheWorldMenu #FileServices #AppRegistry #Preferences #FileList )
		do: [:cl | (Smalltalk at: cl) removeObsolete].
		self unloadMorphicClasses.
	SystemOrganization removeEmptyCategories.
	! !

!ReleaseBuilderFor3dot10 methodsFor: 'updates' stamp: 'edc 4/5/2007 07:11'!
cleanUnwantedCs
	ChangeSet 
		removeChangeSetsNamedSuchThat: [:cs | cs name ~= ChangeSet
current name].
	ChangeSet current clear.
	ChangeSet current name: 'Unnamed1'.
	Smalltalk garbageCollect.! !

!ReleaseBuilderFor3dot10 methodsFor: 'updates' stamp: 'edc 4/1/2007 08:22'!
newUpdate
packagesList := Set new! !

!ReleaseBuilderFor3dot10 methodsFor: 'updates' stamp: 'edc 5/15/2007 08:03'!
newUpdateFor: aBugNo
"  ReleaseBuilderFor3dot10 new  newUpdateFor: nnnn"
|cs updateNo  newName newSet lastName|
mantisNo := aBugNo.
updateNo := SystemVersion current highestUpdate + 1.

lastName := ChangeSet allChangeSetNames last.
	newName _ UIManager default
		request: 'Please name the new change set:'
		initialAnswer: updateNo asString, lastName.
	newName isEmptyOrNil ifTrue:
		[^ nil].
	newSet _ ChangeSet basicNewChangeSet: newName.
	newSet ifNotNil:
		[ChangeSet  newChanges: newSet].
	

cs := newSet .
cs preamble:  '"',(Installer mantis preambleCsForRB: aBugNo) withSqueakLineEndings asUnHtml , '"'.
cs postscript: '"', self postcriptTemplate, aBugNo asString, '"

ReleaseBuilderFor3dot10 new updatePackages: '.
self updateToNext.
cs editPostscript! !

!ReleaseBuilderFor3dot10 methodsFor: 'updates' stamp: 'edc 4/1/2007 10:44'!
postcriptTemplate
^'To follow this see
http://bugs.squeak.org/view.php?id= '! !

!ReleaseBuilderFor3dot10 methodsFor: 'updates' stamp: 'rej 3/5/2007 09:05'!
repository 
  repository isNil ifTrue: [
		repository := MCHttpRepository
                location: 'http://source.squeakfoundation.org/310'
                user: ''
                password: ''.].
  ^repository! !

!ReleaseBuilderFor3dot10 methodsFor: 'updates' stamp: 'muOuser 3/11/2007 10:06'!
updateFrom7067
	"ReleaseBuilderFor3dot10 new updateFrom7067"
	self updatePackages: 'Monticello-rej.309.mcz'.
	"Enable atomic loading"
	self addRepositoryToPackageNamed: 'SystemChangeNotification-Tests'.
	self updatePackages: self packages7067.
	self flushCaches! !

!ReleaseBuilderFor3dot10 methodsFor: 'updates' stamp: 'edc 3/16/2007 07:21'!
updateTo7070
^'EToys-edc.23(md.22).mcd'! !

!ReleaseBuilderFor3dot10 methodsFor: 'updates' stamp: 'edc 3/16/2007 07:26'!
updateTo7071
^'Collections-edc.72(md.71).mcd
CollectionsTests-edc.36(35).mcd
'! !

!ReleaseBuilderFor3dot10 methodsFor: 'updates' stamp: 'edc 7/24/2007 07:30'!
updateToNext

|  pos packString number stream p1 mcc  |
stream := RWBinaryOrTextStream on: String new.
mcc := MCWorkingCopyBrowser new.
mcc  repository: MCCacheRepository default.
mcc workingCopies select:
		[:wc |
		(wc modified = true)] thenDo: [:ea| self saveNewVersion: ea.
		
		packString :=  ea ancestry ancestorString .
		pos := packString indexOf: $..
		p1 := packString copyFrom: 1 to: pos -1.
		number := (packString copyFrom: pos + 1 to: packString size) asNumber.
		packString := p1 ,'.', number  asString , '(', (number - 1) asString ,').mcd'.
		packString := packString, Character cr asString.
		stream nextPutAll: packString
		].
ChangeSet current postscript: ChangeSet current postscript, stream contents! !

!ReleaseBuilderFor3dot10 methodsFor: 'packages' stamp: 'edc 2/26/2007 16:30'!
installInBoxAnd310
	
	
	MCWorkingCopy allManagers do: [:each | 
		each  repositoryGroup
			addRepository: (MCHttpRepository new location: 'http://source.squeakfoundation.org/310' ; user: 'squeak'; password: 'squeak');
			addRepository: (MCHttpRepository new location: 'http://source.squeakfoundation.org/inbox' ; user: '' ; password: '')].! !

!ReleaseBuilderFor3dot10 methodsFor: 'packages' stamp: 'edc 3/14/2007 09:24'!
loadLastVersion: aListOfPackageNames 
| mcw montiNames package version |
mcw := MCWorkingCopyBrowser new repository: (MCHttpRepository
				location: 'http://source.squeakfoundation.org/39a'
				user: ''
				password: '').
mcw repository ifNotNilDo: [:repos | montiNames := repos readableFileNames ].
	
	aListOfPackageNames do: [:mo |
	
	package := (montiNames detect:[:ea| ea beginsWith: mo] ifNone:[] ) .
	package ifNotNil: [
	version := mcw repository loadVersionFromFileNamed: package.
	version load]].
^version! !

!ReleaseBuilderFor3dot10 methodsFor: 'packages' stamp: 'muOuser 3/11/2007 10:06'!
packages7067
	^ 'System-edc.102(sd.101).mcd
Tests-edc.20(sd.19).mcd
Kernel-edc.151(sd.150).mcd
ST80-edc.38.mcz
Monticello-edc.311.mcz
CollectionsTests-edc.35.mcz
Graphics-edc.40(ar.39).mcd
SystemChangeNotification-Tests-edc.7.mcz
GraphicsTests-edc.10(ar.9).mcd
SMBase-edc.86(sd.85).mcd
KernelTests-edc.51(sd.50).mcd
Traits-edc.226.mcz
Files-edc.20.mcz
ToolBuilder-Kernel-rej.18.mcz
XML-Parser-mir.3.mcz
Universes-ls.19.mcz'! !

!ReleaseBuilderFor3dot10 methodsFor: 'packages' stamp: 'edc 3/14/2007 09:16'!
packagesInfluenced

" This is a partial response to Ralph request.
Lets know what packages could touch some code file what we wish go into image.
Intended to load Mantis fix and convert the result to Monticello "
"
ReleaseBuilderFor3dot10 new packagesInfluenced
 "
| realClass cat p  monti fileName cs |
monti := Set new.
fileName := UIManager default chooseFileMatching: #('st' 'cs').
cs := FilePackage fromFileNamed: fileName.
cs classes do: [:cl|  realClass := Smalltalk at: cl name ifAbsent: [ self error: 'This image do not have ', cl asString] .cat := (realClass category findTokens: '-') first.
    
    p := (PackageInfo allPackages collect:[:pi| pi packageName]) .
    (p includes: cat) ifTrue:[ monti add: cat]].
^ monti.! !

!ReleaseBuilderFor3dot10 methodsFor: 'packages' stamp: 'edc 4/1/2007 08:46'!
packagesInfluenced: aStream named: aFileName

" This is a partial response to Ralph request.
Lets know what packages could touch some code file what we wish go into image.
Intended to load Mantis fix and convert the result to Monticello "
"
ReleaseBuilderFor3dot10 new packagesInfluenced
 "
| realClass cat p  monti cs |
monti := Set new.

cs := FilePackage new fromStream: aStream reset named: aFileName.
cs classes do: [:cl|  realClass := Smalltalk at: cl name ifAbsent: [ self error: 'This image do not have ', cl asString] .cat := (realClass category findTokens: '-') first.
    
    p := (PackageInfo allPackages collect:[:pi| pi packageName]) .
    (p includes: cat) ifTrue:[ monti add: cat]].
packagesList addAll:  monti.! !

!ReleaseBuilderFor3dot10 methodsFor: 'packages' stamp: 'edc 7/24/2007 07:41'!
saveNewVersion: v

v repositoryGroup: (self addRepositoryToPackageNamed: v package name).
repository user ifEmpty:[
repository user:  (UIManager default request: '3.10 Repository username').
repository	password: (UIManager default request: '3.10 Repository  password')].

repository storeVersion:  (v newVersionWithName: v uniqueVersionName message: self postcriptTemplate, mantisNo asString)  .
! !

!ReleaseBuilderFor3dot10 methodsFor: 'accessing' stamp: 'edc 5/11/2007 14:36'!
packagesList
 | mcc lista pos |
lista := OrderedCollection new.
mcc := MCWorkingCopyBrowser new.
mcc  repository: MCCacheRepository default.
lista := mcc workingCopies select:
		[:wc |
		((wc modified = true) & wc ancestors notEmpty)] thenCollect: [:ea| |packName| packName := ea  ancestry ancestors first name.
		pos := packName indexOf: $-.
		packName := packName copyFrom: 1 to: pos -1.
		lista add: packName].
	^ lista! !


!ReleaseBuilderFor3dot10 class methodsFor: 'instance creation' stamp: 'edc 4/1/2007 08:32'!
clear

" ReleaseBuilderFor3dot10 clear "
	current:= nil! !

!ReleaseBuilderFor3dot10 class methodsFor: 'instance creation' stamp: 'edc 4/1/2007 08:33'!
current

" ReleaseBuilderFor3dot10 current inspect "
	^current ifNil: [current := (self new) newUpdate]! !


!ReleaseBuilderNihongo methodsFor: 'release' stamp: 'md 2/24/2006 15:59'!
release
	"self release"
	
	Utilities emptyScrapsBook.

	Display setExtent: 960@720 depth: 16.
	World color: (Color r: 0.935 g: 0.935 b: 0.935).

	"Preferences takanawa."
	Preferences setPreference: #magicHalos toValue: false.
	Preferences setPreference: #magicHalos toValue: true.
	Preferences setPreference: #mouseOverHalos toValue: false.
	Preferences setPreference: #mouseOverHalos toValue: true.

	Player abandonUnnecessaryUniclasses.
	Player freeUnreferencedSubclasses.
	Player removeUninstantiatedSubclassesSilently.

	PartsBin initialize.
	Flaps disableGlobalFlaps: false.
	Flaps addAndEnableEToyFlaps.
	ActiveWorld addGlobalFlaps.
	Flaps sharedFlapsAlongBottom.

	Locale currentPlatform: (Locale isoLanguage: 'ja').
	Locale switchToID: (LocaleID isoLanguage: 'ja').
	Preferences restoreDefaultFonts.
	StrikeFont setupDefaultFallbackFont.
	Project current updateLocaleDependents.

	"Dump all projects"
	Project allSubInstancesDo:[:prj| prj == Project current ifFalse:[Project deletingProject: prj]].

	ChangeSet current clear.
	ChangeSet current name: 'Unnamed1'.
	Smalltalk garbageCollect.


! !


!ReleaseBuilderSqueakland methodsFor: 'utilities' stamp: 'mir 11/25/2004 17:14'!
finalCleanup
	"ReleaseBuilder new initialCleanup"


	Smalltalk abandonTempNames.
	Smalltalk zapAllOtherProjects.
	
	super finalCleanup! !

!ReleaseBuilderSqueakland methodsFor: 'utilities' stamp: 'mir 11/25/2004 17:40'!
finalStripping
	"ReleaseBuilderSqueakland new finalStripping"

	#(#Helvetica #Palatino #Courier #ComicSansMS )
		do: [:n | TextConstants
				removeKey: n
				ifAbsent: []].
	Smalltalk
		at: #Player
		ifPresent: [:superCls | superCls
				allSubclassesDo: [:cls | 
					cls isSystemDefined
						ifFalse: [cls removeFromSystem].
					cls := nil]].
	Smalltalk garbageCollect.
	Smalltalk discardFFI; discardSUnit; discardSpeech; yourself.
	"discardMVC;"
	SystemOrganization removeEmptyCategories.
! !

!ReleaseBuilderSqueakland methodsFor: 'utilities' stamp: 'ar 9/27/2005 21:45'!
initialCleanup
	"ReleaseBuilder new initialCleanup"

	Smalltalk at: #Browser ifPresent:[:br| br initialize].
	ChangeSet removeChangeSetsNamedSuchThat:
		[:cs| cs name ~= ChangeSet current name].

	super initialCleanup! !

!ReleaseBuilderSqueakland methodsFor: 'utilities' stamp: 'md 2/24/2006 15:18'!
installPreferences

	#(
		(honorDesktopCmdKeys false)
		(warnIfNoChangesFile false)
		(warnIfNoSourcesFile false)
		(showDirectionForSketches true)
		(menuColorFromWorld false)
		(unlimitedPaintArea true)
		(useGlobalFlaps false)
		(mvcProjectsAllowed false)
		(projectViewsInWindows false)
		(automaticKeyGeneration true)
		(securityChecksEnabled true)
		(showSecurityStatus false)
		(startInUntrustedDirectory true)
		(warnAboutInsecureContent false)
		(promptForUpdateServer false)
		(fastDragWindowForMorphic false)

		(externalServerDefsOnly true)
		(expandedFormat false)
		(eToyFriendly true)
		(eToyLoginEnabled true)
		(magicHalos true)
		(mouseOverHalos true)
		(biggerHandles false)
		(selectiveHalos true)
		(includeSoundControlInNavigator true)
		(readDocumentAtStartup true)
		(preserveTrash true)
		(slideDismissalsToTrash true)
		(propertySheetFromHalo true)

	) do:[:spec|
		Preferences setPreference: spec first toValue: spec last].
	"Workaround for bug"
	Preferences enable: #readDocumentAtStartup.
! !

!ReleaseBuilderSqueakland methodsFor: 'utilities' stamp: 'stephaneducasse 2/3/2006 22:24'!
installReleaseSpecifics
	"ReleaseBuilderSqueakland new installReleaseSpecifics"

	| serverName serverURL serverDir updateServer |

	ProjectLauncher splashMorph: (FileDirectory default readOnlyFileNamed: 'scripts\SqueaklandSplash.morph') fileInObjectAndCode.

	"Dump all morphs so we don't hold onto anything"
	World submorphsDo:[:m| m delete].

	World color: (Color r: 0.9 g: 0.9 b: 1.0).

	"Clear all server entries"
	ServerDirectory serverNames do: [:each | ServerDirectory removeServerNamed: each].
	SystemVersion current resetHighestUpdate.

	"Add the squeakalpha update stream"
	serverName := 'Squeakalpha'.
	serverURL := 'squeakalpha.org'.
	serverDir := serverURL , '/'.

	updateServer := ServerDirectory new.
	updateServer
		server: serverURL;
		directory: 'updates/';
		altUrl: serverDir;
		user: 'sqland';
		password: nil.
	Utilities updateUrlLists addFirst: {serverName. {serverDir. }.}.

	"Add the squeakland update stream"
	serverName := 'Squeakland'.
	serverURL := 'squeakland.org'.
	serverDir := serverURL , '/'.

	updateServer := ServerDirectory new.
	updateServer
		server: serverURL;
		directory: 'public_html/updates/';
		altUrl: serverDir.
	Utilities updateUrlLists addFirst: {serverName. {serverDir. }.}.

! !

!ReleaseBuilderSqueakland methodsFor: 'utilities' stamp: 'stephaneducasse 2/3/2006 22:23'!
installVersionInfo
	"ReleaseBuilderSqueakland new installVersionInfo"

	| highestUpdate newVersion |
	highestUpdate := SystemVersion current highestUpdate.
	(self confirm: 'Reset highest update (' , highestUpdate printString , ')?')
		ifTrue: [SystemVersion current highestUpdate: 0].

	newVersion := FillInTheBlank request: 'New version designation:' initialAnswer: 'Squeakland 3.8.' , highestUpdate printString. 
	SystemVersion newVersion: newVersion.
	(self confirm: self version , '
Is this the correct version designation?
If not, choose no, and fix it.') ifFalse: [^ self].
! !

!ReleaseBuilderSqueakland methodsFor: 'utilities' stamp: 'tak 11/28/2005 17:25'!
setupLanguageSpecifics
	"ReleaseBuilderSqueakland new setupLanguageSpecifics"
	Locale current languageEnvironment setupSqueaklandSpecifics! !

